/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                INTEL CORPORATION PROPRIETARY INFORMATION                //
//   This software is supplied under the terms of a license agreement or   //
//  nondisclosure agreement with Intel Corporation and may not be copied   //
//   or disclosed except in accordance with the terms of that agreement.   //
//       Copyright (c) 2003 Intel Corporation. All Rights Reserved.        //
//                                                                         //
//  File:      pnlFakePtr.hpp                                              //
//                                                                         //
//  Purpose:   declaration of fake pointers and dummies                    //
//                                                                         //
//  Author(s):                                                             //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef __PNLFAKEPTR_HPP__
#define __PNLFAKEPTR_HPP__

#include "pnlConfig.hpp"

PNL_BEGIN

#ifndef PNL_VC6_WITH_BROKEN_TEMPLATES
#define PNL_FAKEPTR( T ) ((T *)FakePtr< T >())
#else
#define PNL_FAKEPTR( T ) ((T *)FakePtr< T >((T)0))
#endif

// remaining is internal stuff

template< typename T >
#ifndef PNL_VC6_WITH_BROKEN_TEMPLATES
inline T *FakePtr()
#else
inline T *FakePtr( T )
#endif
{
    return 0;
}

#define PNLI_FAKEPTR( T ) (&PNLI_FAKEDUMMY( T ))
#define PNLI_FAKEDUMMY( T ) (pnl::global_fakedummy_ ## T)

#ifndef PNL_VC6_WITH_BROKEN_TEMPLATES

#define PNLI_IMPLEMENT_FAKEPTR( T )     \
extern PNL_API T global_fakedummy_ ## T;\
template<>                              \
inline T *FakePtr< T >()                \
{                                       \
    return PNLI_FAKEPTR( T );           \
}

#else

#define PNLI_IMPLEMENT_FAKEPTR( T )     \
extern PNL_API T global_fakedummy_ ## T;\
template<>                              \
inline T *FakePtr< T >( T )             \
{                                       \
    return PNLI_FAKEPTR( T );           \
}

#endif

PNLI_IMPLEMENT_FAKEPTR( float )
PNLI_IMPLEMENT_FAKEPTR( double )
PNLI_IMPLEMENT_FAKEPTR( int )

PNL_END

#endif
