#include "correctToCanonialForm.h"
#include "logFile.h"
#include <cassert>
void claimSons(tree::nodeP fatherP); // see treeUtil.cpp
/*
// small utility:
void claimSons(tree::nodeP fatherP){
	if (fatherP==NULL) return;
	for(int i=0;i<fatherP->sons.size();i++) {
		fatherP->sons[i]->setFather(fatherP);
	}
}
*/
correctToCanonialForm::correctToCanonialForm(tree* t1,
											 const VVdouble& distanceTable,
											 const vector<char>& isRealTaxa)
											 :_isRealTaxa(isRealTaxa),_distances(distanceTable) {
	_etPtr = t1;
}

void correctToCanonialForm::getNodeVectorFromId(vector<tree::nodeP>& all) const {
  vector<tree::nodeP> tmp_all;
  _etPtr->getAllNodes(tmp_all,_etPtr->iRoot());
  all.resize(tmp_all.size());
  for(int i=0;i<tmp_all.size();i++)
    all[tmp_all[i]->id()]=tmp_all[i];
}

void correctToCanonialForm::rootToUnrootedTree(tree& et,vector<int> * nodesThatareTakenOut) {
//	CHECK!!!
	LOG(5,<<"0================== rootToUnrootedTree ==================="<<endl); 
	LOGDO(800,et.output(myLog::LogFile(),tree::ANCESTOR));
	LOG(5,<<"0==================================================="<<endl); 
	if (et.iRoot()->sons[0]->sons.empty()==false) {
		et.iRoot()->sons[1]->setDisToFather
			( et.iRoot()->sons[1]->dis2father()+
			et.iRoot()->sons[0]->dis2father()	);
		et.iRoot()->sons[0]->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
		// in this case we should fill the 3 sons from the other sons.
		for (int k=0; k < et.iRoot()->sons[0]->sons.size(); ++k) {
			et.iRoot()->sons.push_back(et.iRoot()->sons[0]->sons[k]);
		//	MDOUBLE sumOfDis = et.iRoot()->sons[1]->sons[k]->dis2father() + 
		//		et.iRoot()->sons[1]->dis2father();
		//	et.iRoot()->sons[1]->sons[k]->Setdis2father(sumOfDis);
		}
		et.iRoot()->sons[0]->sons.clear();
		claimSons(et.iRoot());
		// there is the chance that the node in son [0] is not a real taxa, and hence should be take out...
//		if (isRealTaxa(et.iRoot()->sons[0])==false) {
//			nodesThatareTakenOut->push_back(et.iRoot()->sons[0]->id());
//			et.iRoot()->sons[0]=et.iRoot()->sons[et.iRoot()->sons.size()-1];
//			et.iRoot()->sons.pop_back();
//		}
	}
	else {// (et.iRoot()->sons[1]->sons.empty()) 
		et.iRoot()->sons[1]->setDisToFather
			( et.iRoot()->sons[0]->dis2father()+
			et.iRoot()->sons[1]->dis2father()	);
		et.iRoot()->sons[1]->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
		// in this case we should fill the 3 sons from the other sons.
		for (int k=0; k < et.iRoot()->sons[1]->sons.size(); ++k) {
			et.iRoot()->sons.push_back(et.iRoot()->sons[1]->sons[k]);
			//MDOUBLE sumOfDis = et.iRoot()->sons[0]->sons[k]->dis2father() + 
			//	et.iRoot()->sons[0]->dis2father();
			//et.iRoot()->sons[0]->sons[k]->Setdis2father(sumOfDis);
		}
		et.iRoot()->sons[1]->sons.clear();
		claimSons(et.iRoot());
		// there is the chance that the node in son [0] is not a real taxa, and hence should be take out...
//		if (isRealTaxa(et.iRoot()->sons[1])==false) {
//			nodesThatareTakenOut->push_back(et.iRoot()->sons[1]->id());
//			et.iRoot()->sons[1]=et.iRoot()->sons[et.iRoot()->sons.size()-1];
//			et.iRoot()->sons.pop_back();
//		}

	}

}

void correctToCanonialForm::correctTree() {
	LOG(800,<<"0================== b4 correcting ==================="<<endl); 
	LOGDO(800,_etPtr->output(myLog::LogFile(),tree::ANCESTOR));
	LOG(800,<<"0==================================================="<<endl); 

	vector<int> nodesThatareTakenOut;

	vector<tree::nodeP> all; // this must be called b4 the nodes exclusion...
	getNodeVectorFromId(all);// all[i] is the node with id = i;

	//bool nextStep = false;
	//while (nextStep == false) {
		makeSureRootIsAnHTU();
		recursiveCleanTreeFromExcessNodes(nodesThatareTakenOut,_etPtr->iRoot());
		if (_etPtr->iRoot()->sons.size()==2) {
			rootToUnrootedTree(*_etPtr,&nodesThatareTakenOut); 
			recursiveCleanTreeFromExcessNodes(nodesThatareTakenOut,_etPtr->iRoot());
		}
		//_etPtr->output(LOG(5,, tree::ANCESTOR,true) );
	//}


	//_etPtr->output(LOG(5,, tree::ANCESTOR,true) );

//	LOG(5,<<"1==================================================="<<endl;//CHEC)K
//	_etPtr->output(LOG(5,, tree::ANCESTOR,true);//CHEC)K
	LOG(800,<<"0================== b4 recursive ==================="<<endl); 
	LOGDO(800,_etPtr->output(myLog::LogFile(),tree::ANCESTOR));
	LOG(800,<<"0==================================================="<<endl); 

	recursiveAddNodesToMisplacedLeaves(nodesThatareTakenOut,_etPtr->iRoot(),all);

//	LOG(5,<<"2==================================================="<<endl;//CHEC)K
//	_etPtr->output(LOG(5,, tree::ANCESTOR,true);//CHEC)K

	recursiveCorrectmOversizedStarsWithExcessNodes(nodesThatareTakenOut,
	  _etPtr->iRoot(),
	  all);  

//	LOG(5,<<"3==================================================="<<endl;//CHEC)K
//	_etPtr->output(LOG(5,, tree::ANCESTOR,true) ;//CHEC)K
}

//bool correctToCanonialForm::isRealTaxa(const tree::nodeP& n1) {
//	return (_pi->getSeq(n1->id()) != NULL);
//}



//void correctToCanonialForm::makeSureRootHasThreeChildOrMore(){
void correctToCanonialForm::makeSureRootIsAnHTU(){
	vector<tree::nodeP> nodes;
	_etPtr->getAllNodes(nodes,_etPtr->iRoot());
	for (int i=0; i < nodes.size() ;++i) {
		if (_isRealTaxa[nodes[i]->id()] == 0) {
			_etPtr->rootAt(nodes[i]);
			break;
		}
	}
	
	// we now have the root in an HTU
	int numOfRootChild = _etPtr->iRoot()->sons.size();
	if (numOfRootChild==0) errorMsg::reportError(" error (0) in function makeSureRootIsAnHTU");
	if (numOfRootChild==1) {// out tree looks like n1 has one son x. x has one or more sons...
		if (_isRealTaxa[_etPtr->iRoot()->sons[0]->id()]) {
			_etPtr->iRoot()->sons[0]->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
			for (int i=0; i < _etPtr->iRoot()->sons[0]->sons.size() ; ++i) {
				_etPtr->iRoot()->sons.push_back(_etPtr->iRoot()->sons[0]->sons[i]);
			}
			_etPtr->iRoot()->sons[0]->sons.clear();
			claimSons(_etPtr->iRoot());
		}
		else _etPtr->rootAt(_etPtr->iRoot()->sons[0]);
		numOfRootChild = _etPtr->iRoot()->sons.size();
		assert (numOfRootChild>1);
		//makeSureRootIsAnHTU();
		//return;
	}
	if (numOfRootChild==2) {
		rootToUnrootedTree(*_etPtr);
	}
}

void correctToCanonialForm::recursiveCleanTreeFromExcessNodes(vector<int>& nodesThatareTakenOut, 
									   tree::nodeP inNode){
// this function handle 2 cases:
// 1. there is an HTU that had been positined as a leaf
// 2. there is an HTU that has only one son.
	if (inNode->sons.empty()) return;
	for (int i =inNode->sons.size()-1 ; i >=0 	 ; --i) {
		recursiveCleanTreeFromExcessNodes(nodesThatareTakenOut,inNode->sons[i]);
		if (inNode->sons[i]->sons.empty() && (_isRealTaxa[inNode->sons[i]->id()]==0)) {
			nodesThatareTakenOut.push_back(inNode->sons[i]->id());
			inNode->sons[i]=inNode->sons[inNode->sons.size()-1];
			inNode->sons.pop_back();
		} else if (inNode->sons[i]->sons.size()==1  && !_isRealTaxa[inNode->sons[i]->id()]) {
			double newDist = inNode->sons[i]->sons[0]->dis2father()+inNode->sons[i]->dis2father();
			nodesThatareTakenOut.push_back(inNode->sons[i]->id());
			inNode->sons[i]=inNode->sons[i]->sons[0];
			inNode->sons[i]->setFather(inNode);
			inNode->sons[i]->setDisToFather(newDist);
		}
    }
}


void SwapSon(tree::nodeP fatherP,
			 tree::nodeP oldSon,
			 tree::nodeP newSon) {
	if (fatherP == NULL) return;
	for(int i=0;i<fatherP->sons.size();i++) {
	
    if (fatherP->sons[i]==oldSon){
      fatherP->sons[i]=newSon;
      return;
    }
  }
  errorMsg::reportError("The bird in the tree is not sitting on this Branch..");
}



void correctToCanonialForm::recursiveAddNodesToMisplacedLeaves(
									vector<int>& nodesThatareTakenOut,
									tree::nodeP inNode,
									const vector<tree::nodeP>& all) {
//-------------------------------------------------------------------------
// fix nodes that are leaves and are not leaves in the span tree:
// if the leaf has a child, the leaf is replaced with a new node,
// and the leaf is now the child of this new node...
//-------------------------------------------------------------------------

	if (inNode->sons.empty()) return;
	for (int i =0 ; i <inNode->sons.size(); ++i) {
		recursiveAddNodesToMisplacedLeaves(nodesThatareTakenOut,inNode->sons[i],all);
	}// we start from the leaves towards the root.

	if (_isRealTaxa[inNode->id()]) {// i.e. taxa with childs...
		if (nodesThatareTakenOut.empty()) {
			errorMsg::reportError(" error in function recursiveAddNodesToMisplacedLeaves -  not enough nodes to add. ");
		}
		tree::nodeP fill_node = all[nodesThatareTakenOut.back()];	// get an unused node
		nodesThatareTakenOut.pop_back(); // clear it from the list
	    tree::nodeP old_father=inNode->father();
		fill_node->setFather(old_father);
		fill_node->sons=inNode->sons;
		fill_node->sons.push_back(inNode);
		fill_node->setDisToFather(inNode->dis2father());
		inNode->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
		inNode->setFather(fill_node);
		inNode->sons.clear();
	    SwapSon(old_father, inNode, fill_node);
		claimSons(fill_node);
		claimSons(old_father);
		//if (_etPtr->isRoot(inNode)) _etPtr->setAsRootSemphy(inNode->father);
	}
}

void correctToCanonialForm::getBestPair(const vector<int> &sons,
				 int& fromi,
				 int& toi,
				 const bool useNJToBrakeUpStars){
	if (useNJToBrakeUpStars) {
		MDOUBLE min=VERYBIG;
		for (int i=0;i<sons.size()-1;++i){
			for (int j=i+1 ;j<sons.size();++j){
				if (_distances[sons[i]][sons[j]]<min) {
					min=_distances[sons[i]][sons[j]];
					fromi=i;
					toi=j;
				}
			}
		}
	} else {
		fromi=0;
		toi=1;
	}
}


 // this function choses the star brakeup rather arbitrarely, and shold be looked into. 

void correctToCanonialForm::recursiveCorrectmOversizedStarsWithExcessNodes(
								vector<int>& nodesThatareTakenOut,
								tree::nodeP nodeToCorrect,
								const vector<tree::nodeP>& all){
	if (nodeToCorrect->sons.empty()) return; // no correction is needed
//	bool node2correctIsTheRoot = _etPtr->isRoot(nodeToCorrect);
	bool node2correctIsTheRoot = nodeToCorrect->isRoot();
	bool correctionIsNeeded = (
			(!node2correctIsTheRoot && 
			nodeToCorrect->sons.size()>2) || 
			
			(node2correctIsTheRoot && 
			nodeToCorrect->sons.size()>3)
	);
	if (correctionIsNeeded) {

  		static vector<int> sons;
		sons.clear();
		for (int iSon=0;iSon<nodeToCorrect->sons.size();iSon++) {
		  sons.push_back(nodeToCorrect->sons[iSon]->id());
		}
		if (!node2correctIsTheRoot) sons.push_back(nodeToCorrect->father()->id());
		int fromi, toi;
		getBestPair(sons, fromi, toi, true); // true = use NJ to break nodes

		tree::nodeP fill_node = all[nodesThatareTakenOut.back()];
		nodesThatareTakenOut.pop_back();
    
		if (toi==nodeToCorrect->sons.size()) {	// the father
			fill_node->setFather(nodeToCorrect);
			fill_node->sons=nodeToCorrect->sons;
			fill_node->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
			nodeToCorrect->sons.clear();
			nodeToCorrect->sons.push_back(fill_node);
			nodeToCorrect->sons.push_back(fill_node->sons[fromi]);
			fill_node->sons[fromi]=fill_node->sons.back(); // this will work even if the the fromi is last in the vector
			fill_node->sons.pop_back();
			  //      _myBNtree.claimSons(nodeToCorrect->father);
			claimSons(fill_node);
			claimSons(nodeToCorrect);
		} else {			// two diffrent sons.  this time, we join them under us, and then recall this function on our self, and return
			fill_node->setFather(nodeToCorrect);
			fill_node->sons.clear();
			fill_node->sons.push_back(nodeToCorrect->sons[fromi]);
			fill_node->sons.push_back(nodeToCorrect->sons[toi]);
			fill_node->setDisToFather(VERY_SMALL_DIST_TO_FATHER);
			nodeToCorrect->sons[fromi]=fill_node;
			nodeToCorrect->sons[toi]=nodeToCorrect->sons.back(); // this will work even if the the toi is last in the vector
			nodeToCorrect->sons.pop_back();
			claimSons(fill_node);
			claimSons(nodeToCorrect);
		}
					// now, we may still have too meny children, so we call ourself, and then return      
		recursiveCorrectmOversizedStarsWithExcessNodes(nodesThatareTakenOut,
			nodeToCorrect,all);
		return;
	}  
	for (int i =0 ; i <nodeToCorrect->sons.size(); ++i) {
		recursiveCorrectmOversizedStarsWithExcessNodes(nodesThatareTakenOut,
		nodeToCorrect->sons[i],all);
	}
}


