#include "bootstrap.h"
#include "treeUtil.h"

using namespace libtree_v1_0_0;

int main()
{
  cout << "creating a bootstrap object from a file"<<endl;
  
  string filename("bootstrap_test.txt");

  vector<tree> tv(getStartingTreeVecFromFile(filename));

  // first constractor
  cout << " first constractor"<<endl;
  bootstrap b1(filename);
  b1.print();
  cout <<endl;

  // secound constractor
  cout << " secound constractor" <<endl;
  bootstrap b2(tv);
  b2.print();
  cout <<endl;
  
  cout << "geing whights from a tree" << endl;
  vector<float> v1(b1.GetWeightsToTree(tv[0])) ;
  for (vector<float>::iterator i = v1.begin();i!=v1.end();++i)
    cout << " "<<*i;
  cout << endl;

  cout << "checkout the support of a tree" <<endl;
  b1.printTreeNH(cout, tv[0], v1);
  cout <<endl <<endl;
  

  cout<< "remove the first tree from the list, and use is as bases for additional computation"<<endl;
  tree t(tv[0]);
  tv[0]=tv[1];
  
  // secound constractor
  bootstrap b3(tv);
  b3.print();
  
  vector<float> v3(b3.GetWeightsToTree(t)) ;
  for (vector<float>::iterator i = v3.begin();i!=v3.end();++i)
    cout << " "<<*i;
  cout << endl;
  
  cout << "checkout the support of the removed tree"<<endl;
  b3.printTreeNH(cout, t, v3);
  cout <<endl;

  set< pair<int,int> > outset;
  vector<float> support;
  cout <<"compatability"<<endl;
  support=b3.thresholdTree(t,outset);

  for (set< pair<int,int> >::iterator i=outset.begin();i!=outset.end();++i)
    {
      cout << "<"<<i->first<<","<<i->second <<">:"<<support[i->first]<<endl;
    }


  cout <<"compatability 0.0"<<endl;
  support=b3.thresholdTree(t,outset,0.);

  for (set< pair<int,int> >::iterator i=outset.begin();i!=outset.end();++i)
    {
      cout << "<"<<i->first<<","<<i->second <<">:"<<support[i->first]<<endl;
    }

  cout <<"compatability 0.8"<<endl;
  support=b3.thresholdTree(t,outset,0.8);

  for (set< pair<int,int> >::iterator i=outset.begin();i!=outset.end();++i)
    {
      cout << "<"<<i->first<<","<<i->second <<">:"<<support[i->first]<<endl;
    }

  


  return (0);
}
