#include <memory>
#include "matanFromInsFile.h"

WeightUpdateStrategy_cl::WeightUpdateType matanFromInsFile::annType() {
  auto_ptr<string> type(searchStringInFile("type",_instructionFile));
  if (type.get() == NULL || type.get()->c_str()=="None")
    return WeightUpdateStrategy_cl::None;
  if (*(type.get())=="Random")
    return WeightUpdateStrategy_cl::Random;
  if (*(type.get())=="Adversarial") {
    //    errorMsg::reportError("Adversarial search not yet implimented");
    return WeightUpdateStrategy_cl::Adversarial;}
  if (*(type.get())=="Prior"){
    errorMsg::reportError("\"Prior\" search not yet implimented");
    return WeightUpdateStrategy_cl::Prior;
  }
  cerr<<"\""<<*(type.get())<<"\""<<endl;
  errorMsg::reportError("Unknown search type");
  return WeightUpdateStrategy_cl::None;
}

void matanFromInsFile::annealingParams(Vdouble &params){
  params.resize(3);
  
  auto_ptr<string> hot(searchStringInFile("hot",_instructionFile));
  if (hot.get() != NULL) params[0]=atof(hot.get()->c_str());
  else errorMsg::reportError("Weight Annealing requires a \"hot\" parameter");
  
  auto_ptr<string> cold(searchStringInFile("cold",_instructionFile));
  if (cold.get() != NULL) params[1]=atof(cold.get()->c_str());
  else errorMsg::reportError("Weight Annealing requires a \"cold\" parameter");
  
  auto_ptr<string> factor(searchStringInFile("factor",_instructionFile));
  if (factor.get() != NULL) params[2]=atof(factor.get()->c_str());
  else errorMsg::reportError("Weight Annealing requires a \"factor\" parameter");
  
}
